/*
info_gpu_mpi.cu (CUDA + MPI)

check GPU, set device, show info
*/

#include "ost.h"
#include "ost_prototype.h"

void info_gpu_mpi(FILE *fp, int nhost, const int ndevice[], int gpu, int um, int commsize, int commrank, int prompt)
{
	if (gpu) {
		char msg[BUFSIZ], str[BUFSIZ];
		char *lstr = (char *)malloc(commsize * BUFSIZ * sizeof(char));

		int device = rank2device(commrank, nhost, ndevice);

		int ierr = check_gpu(device, msg);
		sprintf(str, "  GPU-%d: %s, U.M.%s, device=%d", commrank, msg, (um ? "ON" : "OFF"), device);
		comm_string(str, lstr);
		if (commrank == 0) {
			monitor1(fp, lstr);
		}
		comm_check(ierr, 1, prompt);

		free(lstr);
	}
}
