#ifndef _OST_PROTOTYPE_H_
#define _OST_PROTOTYPE_H_

#ifdef __cplusplus
extern "C" {
#endif

// C
extern double cputime(void);
extern void   echar(int, int, int, int, int, int, int, int, int);
extern void   edge(int, int, int, int, int, int);
extern void   electrode(int, int, int, int, int, int);
extern void   fitgeometry(void);
extern void   final(real_t, real_t, int, int, int, int, int, int);
extern int    geomlines(int, int, int *, int *, double (*)[8], double (*)[2][3], int *, double);
extern void   get_span(double *, int, int, double, double, int *, int *, double);
extern int    ingeometry(double, double, double, int, double *, double);
extern void   initial(real_t *, real_t *, int, int, int, int, int, int);
extern int    input(FILE *, int);
extern void   makeL1d(int, int, int, int, int, int, int, int, int);
extern void   makeP2d(int, int, int, int, int, int, int, int, int);
extern void   monitor1(FILE *, const char []);
extern void   monitor2(FILE *, int, int, int);
extern void   monitor3(FILE *);
extern void   monitor4(FILE *, int);
extern void   monitor5(FILE *, const double []);
extern int    nearest(double, int, int, const double []);
extern void   plot3dGeom(int);
extern void   plotIter(void);
extern void   plotL1d(void);
extern void   plotP2d(void);
extern void   post(int);
extern void   readout(FILE *);
extern void   setupfactor(void);
extern void   setupid(int, int, int, int, int, int);
extern void   setup_cells(int, int, int, int *, int *, int *);
extern void   setup_node(int, int, int, double *, double *, double *, int *, int *, int *);
extern void   setup_1d(void);
extern void   setup_2d(void);
extern int    tokenize(char *, const char [], char *[], size_t);
extern void   writeout(FILE *);

// MPI
extern void   comm_boundary(real_t *, real_t *);
extern void   comm_broadcast(void);
extern void   comm_check(int, int, int);
extern double comm_cputime(void);
extern void   comm_gather(void);
extern void   comm_gather1d(void);
extern void   comm_gather2d(void);
extern void   comm_reduction(void);
extern void   comm_string(const char *, char *);
extern real_t comm_sum(real_t);
extern void   mpi_close(void);
extern void   mpi_init(int, char **);
extern void   setupsize(void);

#ifdef __cplusplus
}
#endif

// C + CUDA
extern void   sor(int, FILE *);

// CUDA
#ifdef __CUDACC__
extern int    check_gpu(int, char []);
extern void   cuda_free(int, void *);
extern void   cuda_malloc(int, int, void **, size_t);
extern void   cuda_memcpy(int, void *, const void *, size_t, cudaMemcpyKind);
extern void   info_gpu(FILE *, int);
extern void   info_gpu_mpi(FILE *, int, const int [], int, int, int, int, int);
extern int    rank2device(int, int, const int []);
#endif

#endif
