%{
OpenSTF : ost.m (MATLAB)
Veesion 3.1.0
%}

clearvars;
%close all;

cpu = [0 0 0];
tic;
%maxNumCompThreads(8);

% open ost.log
ost_log = 'ost.log';
[fid_log, errmsg] = fopen(ost_log, "wt");
if (fid_log < 0)
	fprintf('%s : %s\n', errmsg, ost_log);
	return;
end

% monitor (1)
program = '<<< OpenSTF Version 3.1.0 >>>';
monitor(1, fid_log, program);

% [1] input data
ost_in = 'matlab.ost';
%ost_in = '../data/sample/1st_sample.ost';
%ost_in = '../data/benchmark/benchmark100.ost';
[fid_in, errmsg] = fopen(ost_in, "rt");
if (fid_in < 0)
	fprintf('%s : %s\n', errmsg, ost_in);
	return;
end
[Parm, Mesh, Geom, err] = input_data(fid_in);
if (err > 0)
	return;
end

% plot geometry (3D)
if (Parm.plot3dgeom == 1)
	plot3d_geom(Parm, Mesh, Geom); shg;
end

% monitor (2)
monitor(2, fid_log, Parm, Mesh, Geom);

% [2] setup

[idVolt, Epsr] = setup_id(Parm, Mesh, Geom);

cpu(1) = toc; tic;

% [3] solve
[V, Residual, Niter] = solve(Parm, Mesh, Geom, idVolt, Epsr, fid_log);

cpu(2) = toc; tic;

% [4] charge and energy
[charge, wtotal] = calcchar(Parm, Mesh, idVolt, Epsr, V);

% monitor (3)
monitor(3, fid_log, Parm, charge, wtotal);

% monitor (4)
monitor(4, fid_log);

% [5] save
save 'ost.mat' Parm Mesh Geom idVolt Epsr V Residual Niter

% monitor (5)
cpu(3) = toc;
monitor(5, fid_log, cpu);

fclose('all');
% end
