%{
OpenSTF : ost_post.m (MATLAB, post)
Version 3.1.0
%}

clearvars;
%close all;

% [0-1] load
load 'ost.mat' Parm Mesh Geom idVolt Epsr V Residual Niter

% [0-2] read post data
ost_in = 'matlab.ost';
[fid_in, errmsg] = fopen(ost_in, "rt");
if (fid_in < 0)
	fprintf('%s : %s\n', errmsg, ost_in);
	return;
end
Post = post_data(fid_in);

% [1] iteration (2D)
if (Post.iter > 0)
	plotiter(Parm, Post, Residual, Niter);
end

% [2] line (2D)
if (Post.p1ddir(1) ~= "")
	plot1d(Parm, Mesh, Post, idVolt, Epsr, V);
end

% [3] plane (2D)
if (Post.p2ddir(1) ~= "")
	plot2d(Parm, Mesh, Geom, Post, idVolt, Epsr, V);
end

fclose('all');
%end
