/*
setupsize.c (MPI)

setup array size
*/

#include "ost.h"
#include "ost_mpi.h"
#include "ost_prototype.h"

void setupsize()
{
	// too many prosess

	if (commSize > Nx) {
		if (commRank == 0) {
			fprintf(stderr, "*** too many processes = %d (limit = %d)\n", commSize, Nx);
			fflush(stderr);
		}
		comm_check(1, 0, 1);
	}

	// min and max node number, X direction only

	iMin = (commRank == 0) ? 0 : (commRank * Nx / commSize) + 1;
	iMax = (commRank == commSize - 1) ? Nx : ((commRank + 1) * Nx / commSize);
	iMin2 = (commRank == 0) ? 0 : (iMin - 1);
	iMax2 = (commRank == commSize - 1) ? Nx : (iMax + 1);

	jMin = 0;
	jMax = Ny;
	jMin2 = jMin;
	jMax2 = jMax;

	kMin = 0;
	kMax = Nz;
	kMin2 = kMin;
	kMax2 = kMax;
	//printf("%d %d %d %d %d %d\n", commSize, commRank, iMin, iMax, iMin2, iMax2); fflush(stdout);
}
