/*
makeL1d.c

make 1d data
*/

#include "ost.h"
#include "ost_prototype.h"
#include "vedq.c"

void makeL1d(int imin, int imax, int jmin, int jmax, int kmin, int kmax, int imin2, int jmin2, int kmin2)
{
	if (NL1d < 1) return;
	const int ncompo = 10;
	const int length = MAX(Nx + 1, MAX(Ny + 1, Nz + 1));

	// setup
	if (runMode == 2) {
		setup_1d();
	}

	// alloc
	F1d = (double ***)malloc(NL1d * sizeof(double **));
	for (int n = 0; n < NL1d; n++) {
		F1d[n] = (double **)malloc(ncompo * sizeof(double *));
		for (int ic = 0; ic < ncompo; ic++) {
			F1d[n][ic] = (double *)malloc(length * sizeof(double));
			memset(F1d[n][ic], 0, length * sizeof(double));
		}
	}

	// make data
	double *f = (double *)malloc(ncompo * sizeof(double));
	for (int n = 0; n < NL1d; n++) {
		char dir = L1d[n].direction;
		int idata1 = (dir == 'X') ? imin : (dir == 'Y') ? jmin : kmin;
		int idata2 = (dir == 'X') ? imax : (dir == 'Y') ? jmax : kmax;
		for (int idata = idata1; idata <= idata2; idata++) {
			int i = (dir == 'X') ? idata : (dir == 'Y') ? L1d[n].posid[1] : L1d[n].posid[0];
			int j = (dir == 'Y') ? idata : (dir == 'Z') ? L1d[n].posid[1] : L1d[n].posid[0];
			int k = (dir == 'Z') ? idata : (dir == 'X') ? L1d[n].posid[1] : L1d[n].posid[0];
			// V/E/D/Q
			vedq(i, j, k, f, imin, imax, jmin, jmax, kmin, kmax, imin2, jmin2, kmin2);
			for (int ic = 0; ic < ncompo; ic++) {
				F1d[n][ic][idata] = f[ic];
			}
		}
	}
	free(f);
}
